package com.adventurer_engine.client.model.tmt;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import atc;
import com.adventurer_engine.client.model.tmt.Angle3D;
import com.adventurer_engine.client.model.tmt.Bone;
import com.adventurer_engine.client.model.tmt.PositionTransformVertex;
import com.adventurer_engine.client.model.tmt.TransformGroup;
import ls;

public class TransformGroupBone extends TransformGroup {
  protected Angle3D baseAngles;
  
  protected atc baseVector;
  
  protected Bone attachedBone;
  
  protected double weight;
  
  public TransformGroupBone(Bone bone, double wght) {
    this.baseVector = bone.getPosition();
    this.baseAngles = bone.getAbsoluteAngle();
    this.attachedBone = bone;
    this.weight = wght;
  }
  
  public Angle3D getBaseAngles() {
    return this.baseAngles.copy();
  }
  
  public Angle3D getTransformAngle() {
    Angle3D returnAngle = this.attachedBone.getAbsoluteAngle().copy();
    returnAngle.angleX -= this.baseAngles.angleX;
    returnAngle.angleY -= this.baseAngles.angleY;
    returnAngle.angleZ -= this.baseAngles.angleZ;
    return returnAngle;
  }
  
  public atc getBaseVector() {
    return atc.a(this.baseVector.c, this.baseVector.d, this.baseVector.e);
  }
  
  public atc getTransformVector() {
    return this.baseVector.a(this.attachedBone.getPosition());
  }
  
  public atc getCurrentVector() {
    return this.attachedBone.getPosition();
  }
  
  public double getWeight() {
    return this.weight;
  }
  
  public void attachBone(Bone bone) {
    this.baseVector = bone.getPosition();
    this.baseAngles = bone.getAbsoluteAngle();
    this.attachedBone = bone;
  }
  
  public atc doTransformation(PositionTransformVertex vertex) {
    atc vector = atc.a(vertex.neutralVector.c, vertex.neutralVector.d, vertex.neutralVector.e);
    vector = getBaseVector().a(vector);
    Angle3D angle = getTransformAngle();
    setVectorRotations(vector, angle.angleX, angle.angleY, angle.angleZ);
    return vector;
  }
  
  protected void setVectorRotations(atc vector, float xRot, float yRot, float zRot) {
    float x = xRot;
    float y = yRot;
    float z = zRot;
    float xC = ls.b(x);
    float xS = ls.a(x);
    float yC = ls.b(y);
    float yS = ls.a(y);
    float zC = ls.b(z);
    float zS = ls.a(z);
    double xVec = vector.c;
    double yVec = vector.d;
    double zVec = vector.e;
    double xy = xC * yVec - xS * zVec;
    double xz = xC * zVec + xS * yVec;
    double yz = yC * xz - yS * xVec;
    double yx = yC * xVec + yS * xz;
    double zx = zC * yx - zS * xy;
    double zy = zC * xy + zS * yx;
    xVec = zx;
    yVec = zy;
    zVec = yz;
    vector.c = xVec;
    vector.d = yVec;
    vector.e = zVec;
  }
}
